#!/usr/bin/env python3

import sys
from PyQt5 import QtCore, QtWidgets

class CustomDock(QtWidgets.QDockWidget):

    def __init__(self, parent=None):
        super(CustomDock, self).__init__("Dock Window", parent)

        L = self.layout()
        L.deleteLater()
        QtCore.QCoreApplication.sendPostedEvents(L, QtCore.QEvent.DeferredDelete)

if __name__ == '__main__':
    app = QtWidgets.QApplication(sys.argv)
    win = QtWidgets.QMainWindow()
    win.addDockWidget(QtCore.Qt.RightDockWidgetArea, CustomDock())
    win.show()
    app.exec_()
